/*
 JackWidget 1.1
 http://www.redwork.org

 Copyright (C) 2005, Dave Richmond
 daver@redwork.org
 
 Released under GNU General Public License
 
 This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

For a copy of the licence, go to 
http://www.gnu.org/copyleft/gpl.html


 portions Copyright (C) 2005, Apple Computer, Inc.
 (preferences button animation)

*/
 
var consoleWindow;
var splitChar = "/";
var queryChar = "?"; 

function setup(elem) {
	ptoc("------------------------------");
	ptoc("window.location =" + window.location);
	
	urlsfile = openXMLfile("urls.xml");
	urls = parseURLs(urlsfile);

	searchesfile = openXMLfile("searches.xml");
	searches = parseSearches(searchesfile);

	// populate popup box choices
	for (i in searches) {
		//ptoc(i);
		newOption = new Option(searches[i].caption, searches[i].id);
		document.getElementById("popupMenu").add(newOption);
	}
	// window.onkeypress = keyPressed(event);
	return 0;
}

function parseURLs(file) {
	var urls = new Array();
	var x = file.responseXML.getElementsByTagName("urls");

	//ptoc(enumobjs(document.getElementById("searchField")));
	
	for (i=0; i<x[0].childNodes.length; i++) {
		var nNode = x[0].childNodes[i];
		if (nNode.nodeType != 1) continue;
		var id = nNode.getAttribute("id");
		
		newurl = new urlDef();
		fields = new Array();
		fieldcounter = 0
		for (j=0; j<nNode.childNodes.length; j++) {
			var nodeName = nNode.childNodes[j].nodeName;
			//ptoc("Found Node " + nodeName);
			if (nodeName != "#text" && nNode.childNodes[j].firstChild != null) {
				var nodeValue =	nNode.childNodes[j].firstChild.nodeValue;
				// ptoc(nodeName + " = " + nodeValue);
				if (nodeName == "field") fields[fieldcounter++] = nodeValue;
				else newurl[nodeName] = nodeValue;
			}
		}
		newurl["numfields"] = fieldcounter;
		newurl["fields"] = fields
		newurl["id"] = id;
		urls[newurl["id"]] = newurl;
		//ptoc("added url " + id);
	}
	//for (i in urls) ptoc("url " + i + " = " + urls[i].numfields);
	return urls;
}


function parseSearches(file) {
	var searches = new Array();
	var x = file.responseXML.getElementsByTagName("searches");
	
	//ptoc(enumobjs(document.getElementById("searchField")));
	
	//q = new searchDef();
	//q.id = "query";
	//q.caption = "Query";
	//q.placeholder = "query keywords";
	//searches["query"] = q;
	
	for (i=0; i<x[0].childNodes.length; i++) {
		var nNode = x[0].childNodes[i];
		if (nNode.nodeType != 1) continue;
		var id = nNode.getAttribute("id");
		
		newsearch = new searchDef();
		urllist = new Array();
		urlcounter = 0
		// ptoc("newsearch" + newsearch);
		for (j=0; j<nNode.childNodes.length; j++) {
			var nodeName = nNode.childNodes[j].nodeName;
			// ptoc("Found Node " + nodeName);
			if (nodeName != "#text" && nNode.childNodes[j].firstChild != null) {
				var nodeValue =	nNode.childNodes[j].firstChild.nodeValue;
				if (nodeName == "url") urllist[urlcounter++] = nodeValue;
				else newsearch[nodeName] = nodeValue;
				// ptoc("set newsearch[" + nodeName + "] = " +  newsearch[nodeName]);
				// ptoc(nodeName + " = " + nodeValue);
			}
		}
		newsearch["id"] = id;
		newsearch["numurls"] = urlcounter;
		newsearch["urllist"] = urllist;
		searches[newsearch["id"]] = newsearch;
	}
	return searches;
}


function popupChanged() {
	var s = document.getElementById("searchField");
	// set placeholder to new item
	s.setAttribute("placeholder",searches[document.getElementById("popupMenu").value].placeholder);
	// if text in field give focus back
	if (s.value != "") { s.focus(true); s.select(); }
}

function keyPressed(event) {
	//ptoc("a key was pressed! something is afoot! :" + event.keyCode);
	switch(event.keyCode) {
		case 27:
			searchField.blur(); 
			break;
		case 9:
			popupMenu.focus(); 
			break;
		default:
			//searchField.focus();
			break;
	}
}

function search() {
	ptoc("begin - search()");
	var theurl = "";
	var searchid = document.getElementById("popupMenu").value;
	var searchString = trim(document.getElementById("searchField").value);
	ptoc("searchString = >" + searchString + "<");
	if (searchString.length == 0) return;
	ptoc("flag1");		
	ptoc("searchString.substring(0,0) = >" + searchString.substring(0,1) + "<"); 
	if (searchid=="query" || searchString.substring(0,1) == queryChar) { // parse the query
		ptoc("searchid=='query'");
		ptoc("new searchString = >" + searchString + "<");
		// get chars until first space
		ptoc("get first set of chars");
		var firstspaceindex = searchString.indexOf(" ");
		ptoc("firstspaceindex = " + firstspaceindex);
		var startind;
		if (searchString.substring(0,1) == queryChar) startind = 1;
		else startind = 0;
		prefix = searchString.substring(startind,firstspaceindex);
		ptoc("prefix = " + prefix);
		// find associated search and set id to associated search
		for (i in searches) if (searches[i].abbreviation == prefix) {searchid = searches[i].id; break;}
		ptoc("found id of search");
		// trim search string
		searchString = searchString.substring(firstspaceindex+1,searchString.length);
		ptoc("searchS = " + searchString);
	} 
	ptoc("flag2");			
	urllist = searches[searchid].urllist;
	for (i in urllist) {
		ptoc("i = " + i);
		theurl = "";
		ptoc("urls = " + urllist.toString());
		ptoc("urls[i] = " + urllist[i]);
		var currurl = urls[urllist[i]];
		ptoc("flag 2.3");
		ptoc("currurl = " + currurl);
		var replacewith = currurl.replacespacewith;
		ptoc("flag2.5");
		if (currurl.numfields == 0) { // non parsed
			ptoc("nonparsed");
			ptoc("currurl.urlstring = " + currurl.urlstring);
			theurl = currurl.urlstring + replaceSpaces(searchString, replacewith);
			ptoc("theurl = " + theurl);
		} else { // build url by parsing search string delimited by commas
			ptoc("delimited, searchString = " + searchString);
			theurl = currurl.urlstring;
			splitString = searchString.split(splitChar);
			var numfields = currurl.fields.length;
			ptoc("numfields=" + numfields);
			for (j in splitString) {
				ptoc("j = " + j);
				if (j <= numfields) 
					theurl += currurl.fields[j] + replaceSpaces(trim(splitString[j]), replacewith);
				else {
					theurl += replaceSpaces(" " + trim(splitString[j]), replacewith);
				}
			}
		}
		ptoc("theurl = " + theurl);
		if (window.widget) {
			widget.openURL(theurl);
		} else {
			location = theurl;
		}
	}
	ptoc("flag3");		

}

function replaceSpaces(searchString, replaceString) {
	var b = "";
	if (replaceString == "") replaceString = "+";
	if (replaceString != "") {
		for (i=0; i< searchString.length; i++) {
			if (searchString[i] == " ") b = b + replaceString;
			else b = b + searchString[i];
		}
		return b;
	} else {
		return searchString;
	}
}

function trim(astring) {
	//use regexp to 'unmatch' the beginning and ending whitespace from a string
	if (astring != "") return astring.match(/(\S.*\S)|\S/g).toString();
	else return astring;
}

//object definitions
function searchDef() {
	this.id = "";  
	this.abbreviation = "";
	this.caption = "";
	this.placeholder = ""; 
	this.urllist = new Array(); 
}

function urlDef() {
	this.id = "";
	this.urlstring = "";
	this.fields = new Array();
	this.numfields = 0;
	this.replacespacewith = ""; // string to replaces spaces with
}


// XML routines
function openXMLfile(name) {
	req = new XMLHttpRequest();
	req.onreadystatechange = processReqChange;
	req.overrideMimeType("text/xml");
	req.open("GET", name, false);
	req.setRequestHeader("Cache-Control", "no-cache");
	req.send(null);
	return req
}


// handle onreadystatechange event of req object
function processReqChange() {
    // only if req shows "loaded"
    if (req.readyState == 4) {
        // only if "OK"
        if (req.status != 200) {
            alert("There was a problem retrieving the XML data:\n" +
                req.status + " : " + req.statusText);
         }
    }
}

function getHelp() {
	var loc = window.location.toString();
	ptoc("window.loc = " + loc);
	var firstslash = loc.indexOf("/");
	var path = loc.slice(0, firstslash) + "//" + loc.slice(firstslash, loc.lastIndexOf("/") + 1);
	var theurl = path + "site/main.html";
	ptoc("theurl = " + theurl);
	if (window.widget) {
		widget.openURL(theurl);
	} else {
		location = theurl;
	}
}

// debugging
function ptoc(aMessage) {
	if (!window.widget) {
		if (consoleWindow == null) {
			consoleWindow = window.open("", "tinyWindow", 'width=500,height=800') 
		}
		consoleWindow.document.write(aMessage + "<br>");
	}
}

function enumobjs(a) {
	s="";
	for (i in a) {
		s += i + " = " + a.i + "<br>";
	}	
	return s;
}

function mouseOver(thing) {
	thing.style.textDecoration='underline';
	thing.style.cursor = 'pointer';
}
	
function mouseOut(thing) {
	thing.style.textDecoration='none';
	thing.style.cursor = 'auto';
}


// The remainder of the code was taken from Apple's widget progrramming examples

// front/back side flipping	
function showPrefs()
{
	var front = document.getElementById("front");		// first, you need to get the front
	var back = document.getElementById("back");			// and back layers
	
	if(window.widget)									// this freezes the currently visible
		widget.prepareForTransition("ToBack");			// layer
	
	front.style.display="none";							// the preferences layer is made
	back.style.display="block";							// visible and the picture is hidden
				
	if(window.widget)									// the flip transition is run, with the
		setTimeout ('widget.performTransition();', 0);	// frozen side on the front and the
														// preferences on the back

	document.prefButtonHighlight.style.display='none';
}

// When the "Done" button is clicked in the preferences, this function is called. It swaps
// the preference layer out with the picture and frame.
function hidePrefs()
{
	
	document.getElementById("doneButton").src = "Images/done.png";  // restore the regular
																	// "Done" button

	var front = document.getElementById("front");		// again, you need to obtain the front
	var back = document.getElementById("back");			// and back layers
	
	if (window.widget)									// then freeze the visible layer (as seen
		widget.prepareForTransition("ToFront");			// by the user
	
	front.style.display="block";						// hide the preferences layer and shot the 
	back.style.display="none";							// main picture layer
	
	if (window.widget)									// and run the flip transition; note that since
		setTimeout ('widget.performTransition();', 0);	// finishEdit() was used to freeze the UI, this 
}


